<?php
/**
 * InvitationCode Plugin
 * 邀请码注册
 *
 */
class InvitationCode_Action extends Typecho_Widget implements Widget_Interface_Do
{
    /** @var  数据操作对象 */
    private $_db;

    /** @var  插件配置信息 */
    private $_cfg;
    
    /** @var  系统配置信息 */
    private $_options;

    /**
     * 初始化
     * @return $this
     */
    public function init()
    {
        $this->_db = Typecho_Db::get();
        $this->_options = $this->widget('Widget_Options');
        $this->_cfg = Helper::options()->plugin('InvitationCode');
    }

    /**
     * action 入口
     *
     * @access public
     * @return void
     */
    public function action()
    {
        $this->on($this->request->is('do=generateCode'))->generateCode();
    }

    /**
     * 邮件发送测试
     */
    public function generateCode()
    {
        if (Typecho_Widget::widget('InvitationCode_Console')->generateCodeForm()->validate()) {
            $this->response->goBack();
        }

        $this->init();
        $open_cxa = $this->_cfg->open_cxa;
        if($open_cxa == 'on'){
            $form_data = $this->request->from('toNum_cxa');
            $prefix_cxa = $this->_cfg->prefix_cxa;
            $num_cxa = $this->_cfg->num_cxa;
            $db_prefix = $this->_db->getPrefix();
            for($i=1; $i <= $form_data['toNum_cxa']; $i++){
                $code = $prefix_cxa.date('yd').$this->randCode(12,0).date('s');
                $insert = $this->_db->insert("{$db_prefix}invitation_code")
                        ->rows(array('num' => $num_cxa, 'code' => $code));
                $insertId = $this->_db->query($insert);
            }
            $result = true;
            /** 提示信息 */
            $this->widget('Widget_Notice')->set(true === $result ? _t('邀请码生成成功') : _t('邀请码生成失败'),
                true === $result ? 'success' : 'notice');
        }else{
            /** 提示信息 */
            $this->widget('Widget_Notice')->set(_t('设置中未开启邀请码'),'notice');
        }

        /** 转向原页 */
        $this->response->goBack();
    }

    function randCode($length = 5, $type = 0) {
        $arr = array(1 => "0123456789", 2 => "abcdefghijklmnopqrstuvwxyz", 3 => "ABCDEFGHIJKLMNOPQRSTUVWXYZ", 4 => "~@#$%^&*(){}[]|");
        if ($type == 0) {
            array_pop($arr);
            $string = implode("", $arr);
        } else if ($type == "-1") {
            $string = implode("", $arr);
        } else {
            $string = $arr[$type];
        }
        $count = strlen($string) - 1;
        $code='';
        for ($i = 0; $i < $length; $i++) {
            $str[$i] = $string[rand(0, $count)];
            $code .= $str[$i];
        }
        return $code;
    }
}